from sqlalchemy import Column, Integer, String, TIMESTAMP, ForeignKey, UniqueConstraint, func
from sqlalchemy.orm import relationship

from .base import Base

class BookCategory(Base):
    __tablename__  = 'book_category'
    __table_args__ = (UniqueConstraint('name'),)

    id                 = Column(Integer, primary_key=True, autoincrement=True)
    parent_category_id = Column(Integer, ForeignKey('book_category.id'), nullable=True)
    name               = Column(String(100), nullable=False)
    mature_content     = Column(Integer, nullable=False, default=0)
    last_updated       = Column(TIMESTAMP, nullable=False, server_default=func.now())

    parent_category = relationship('BookCategory', remote_side=[id])
